package errors

const INVALID_PARAMETER = 400
const ACTION_FORBIDDEN = 401
const NOT_FOUND = 404
const INTERNAL_ERROR = 500

type apiErrorParameter struct {
	ErrorType string `json:"type"`
	Parameter string `json:"parameter"`
	Message   string `json:"message"`
}

type apiError struct {
	ErrorType string `json:"type"`
	Message   string `json:"message"`
}

var errors []interface{}

func InvalidParameter(parameter string, message string) {
	var e = apiErrorParameter{
		"invalid_parameter",
		parameter,
		message,
	}

	errors = append(errors, e)
}

func ActionForbidden(message string) {
	var e = apiError{
		"action_forbidden",
		message,
	}

	errors = append(errors, e)
}

func InternalError(message string) {
	var e = apiError{
		"internal_error",
		message,
	}

	errors = append(errors, e)
}

func NotFound(message string) {
	var e = apiError{
		"not_found",
		message,
	}

	errors = append(errors, e)
}

func Has() bool {
	return len(errors) <= 0
}
